Package: WDI
Title: World Development Indicators and Other World Bank Data
Description: Search and download data from over 40 databases hosted by the World Bank, including the World Development Indicators ('WDI'), International Debt Statistics, Doing Business, Human Capital Index, and Sub-national Poverty indicators.
Authors@R: c(
    person("Vincent", "Arel-Bundock",
           email = "vincent.arel-bundock@umontreal.ca",
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-2042-7063")),
    person("Etienne", "Bacher",
           email = "etienne.bacher@protonmail.com",
           role = "ctb"))
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
LazyData: yes
Type: Package
LazyLoad: yes
Encoding: UTF-8
Version: 2.7.10
URL: https://vincentarelbundock.github.io/WDI/
BugReports: https://github.com/vincentarelbundock/WDI/issues
Depends: R (>= 3.5.0)
Imports: jsonlite
Suggests: altdoc, curl, testthat, tidyr (>= 0.8.0)
RoxygenNote: 7.3.2
License: GPL-3
NeedsCompilation: no
Packaged: 2026-04-05 10:56:10 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>),
  Etienne Bacher [ctb]
Repository: CRAN
Date/Publication: 2026-04-05 11:30:02 UTC
Built: R 4.5.2; ; 2026-04-08 01:06:27 UTC; unix

Package: WDI
Title: World Development Indicators and Other World Bank Data
Description: Search and download data from over 40 databases hosted by the World Bank, including the World Development Indicators ('WDI'), International Debt Statistics, Doing Business, Human Capital Index, and Sub-national Poverty indicators.
Authors@R: c(
    person("Vincent", "Arel-Bundock",
           email = "vincent.arel-bundock@umontreal.ca",
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-2042-7063")),
    person("Etienne", "Bacher",
           email = "etienne.bacher@protonmail.com",
           role = "ctb"))
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
LazyData: yes
Type: Package
LazyLoad: yes
Encoding: UTF-8
Version: 2.7.10
URL: https://vincentarelbundock.github.io/WDI/
BugReports: https://github.com/vincentarelbundock/WDI/issues
Depends: R (>= 3.5.0)
Imports: jsonlite
Suggests: altdoc, curl, testthat, tidyr (>= 0.8.0)
RoxygenNote: 7.3.2
License: GPL-3
NeedsCompilation: no
Packaged: 2026-04-05 10:56:10 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>),
  Etienne Bacher [ctb]
Repository: CRAN
Date/Publication: 2026-04-05 11:30:02 UTC
Built: R 4.6.0; ; 2026-04-25 19:47:49 UTC; unix

# World Bank data in `R`

The `WDI` package allows users to search and download data from over 40
datasets hosted by the World Bank, including the World Development
Indicators (‘WDI’), International Debt Statistics, Doing Business, Human
Capital Index, and Sub-national Poverty indicators.

<!-- badges: start -->

<a href = "https://vincentarelbundock.github.io/WDI/" target = "_blank"><img src="https://img.shields.io/static/v1?label=Website&message=Visit&color=blue"></a>
![CRAN downloads](http://cranlogs.r-pkg.org/badges/grand-total/WDI.png)
[![R build
status](https://github.com/vincentarelbundock/WDI/workflows/R-CMD-check/badge.svg)](https://github.com/vincentarelbundock/WDI/actions)
<!-- badges: end -->

## Installation

`WDI` is published on CRAN and so can be installed by simply typing this
in the `R` console:

``` r
install.packages('WDI')
```

To install the development version of the package, use `remotes`:

``` r
library(remotes)
install_github('vincentarelbundock/WDI')
```

## Searching for data

You can search for data by using keywords in `WDIsearch`. For instance,
if you are looking for data on Gross Domestic Product:

``` r
WDIsearch('gdp')
```

Which produces this:

``` r
> WDIsearch('gdp')[1:10,]
      indicator              name                                                                      
 [1,] "BG.GSR.NFSV.GD.ZS"    "Trade in services (% of GDP)"                                            
 [2,] "BM.KLT.DINV.GD.ZS"    "Foreign direct investment, net outflows (% of GDP)"                      
 [3,] "BN.CAB.XOKA.GD.ZS"    "Current account balance (% of GDP)"                                      
 [4,] "BN.CUR.GDPM.ZS"       "Current account balance excluding net official capital grants (% of GDP)"
 [5,] "BN.GSR.FCTY.CD.ZS"    "Net income (% of GDP)"                                                   
 [6,] "BN.KLT.DINV.CD.ZS"    "Foreign direct investment (% of GDP)"                                    
 [7,] "BN.KLT.PRVT.GD.ZS"    "Private capital flows, total (% of GDP)"                                 
 [8,] "BN.TRF.CURR.CD.ZS"    "Net current transfers (% of GDP)"                                        
 [9,] "BNCABFUNDCD_"         "Current Account Balance, %GDP"                                           
[10,] "BX.KLT.DINV.WD.GD.ZS" "Foreign direct investment, net inflows (% of GDP)" 
```

`WDIsearch` uses grep and ignores cases, so you can also use regular
expressions. For instance, if you are looking for GDP per capita in
constant dollars:

``` r
WDIsearch('gdp.*capita.*constant')
     indicator           name                                                 
[1,] "GDPPCKD"           "GDP per Capita, constant US$, millions"             
[2,] "NY.GDP.PCAP.KD"    "GDP per capita (constant 2000 US$)"                 
[3,] "NY.GDP.PCAP.KN"    "GDP per capita (constant LCU)"                      
[4,] "NY.GDP.PCAP.PP.KD" "GDP per capita, PPP (constant 2005 international $)"
```

## Download and use the data

Download a series you like for the countries you like:

``` r
dat = WDI(indicator='NY.GDP.PCAP.KD', country=c('MX','CA','US'), start=1960, end=2012)
```

Look at the data:

``` r
head(dat)
  iso2c country NY.GDP.PCAP.KD year
1    CA  Canada       9374.883 1960
2    CA  Canada       9479.824 1961
3    CA  Canada       9967.366 1962
4    CA  Canada      10290.362 1963
5    CA  Canada      10774.653 1964
6    CA  Canada      11283.606 1965
```

Plot the data:

``` r
library(ggplot2)
ggplot(dat, aes(year, NY.GDP.PCAP.KD, color=country)) + geom_line() + 
    xlab('Year') + ylab('GDP per capita')
```

<figure>
<img
src="https://raw.githubusercontent.com/vincentarelbundock/WDI/main/web/gdp_per_capita.jpg"
alt="GDP per capita in North America" />
<figcaption aria-hidden="true">GDP per capita in North
America</figcaption>
</figure>

Note: You can use `country='all'` to download data for all available
countries. You can also feed a vector of indicator strings if you want
to download multiple indicators at once.

## Monthly or quarterly data

Some World Bank series are available at the monthly or quarterly
frequency. You can download those simply using the `start` and `end`
arguments:

``` r
WDI(indicator = 'DPANUSSPB', country = 'CHN', start = '2012M01', end = '2012M05')

  iso2c country DPANUSSPB    year
1   CHN   China  6.324130 2012M05
2   CHN   China  6.303810 2012M04
3   CHN   China  6.313545 2012M03
4   CHN   China  6.300286 2012M02
5   CHN   China  6.313091 2012M01
```

## Automatic rename

If the vector that you supply to `WDI` is named, the function will
automatically rename columns where possible.

``` r
dat <- WDI(indicator = c("gdp_per_capita" = "NY.GDP.PCAP.KD",
                         "population" = "SP.POP.TOTL"))
head(dat)
iso2c    country year gdp_per_capita population
1    1A Arab World 2005       5378.379  316264728
2    1A Arab World 2006       5594.899  323773264
3    1A Arab World 2007       5711.663  331653797
4    1A Arab World 2008       5898.516  339825483
5    1A Arab World 2009       5782.422  348145094
6    1A Arab World 2010       5916.330  356508908
```

## Updating series list

To speed up search, `WDI` ships with a local list of all available WDI
series. This list will be updated semi-regularly, but you may still want
to update it manually to get access to the very latest data series. To
do so, use the `cache` function:

``` r
WDI_data = WDIcache()
WDIsearch('gdp', cache=new_cache)
```

Developer note: To update the search cache, just save it to the repo:

``` r
save(WDI_data, file = "data/WDI_data.RData")
```

## Bugs, suggestions, etc.

Thanks for using `WDI`! Please send all bug reports and suggestions
through the github issue tracker or by email to
vincent.arel-bundock@umontreal.ca

# World Bank data in `R`

The `WDI` package allows users to search and download data from over 40 datasets hosted by the World Bank, including the World Development Indicators ('WDI'), International Debt Statistics, Doing Business, Human Capital Index, and Sub-national Poverty indicators.

<!-- badges: start -->
![CRAN downloads](http://cranlogs.r-pkg.org/badges/grand-total/WDI)
[![AppVeyor build status](https://ci.appveyor.com/api/projects/status/github/vincentarelbundock/WDI?branch=master&svg=true)](https://ci.appveyor.com/project/vincentarelbundock/WDI)
[![R build status](https://github.com/vincentarelbundock/WDI/workflows/R-CMD-check/badge.svg)](https://github.com/vincentarelbundock/WDI/actions)
<!-- badges: end -->

# Installation

`WDI` is published on CRAN and so can be installed by simply typing this in the `R` console: 

```r
install.packages('WDI')
```

To install the development version of the package, use `remotes`:

```r
library(remotes)
install_github('vincentarelbundock/WDI')
```

# Searching for data

You can search for data by using keywords in `WDIsearch`. For instance, if you are looking for data on Gross Domestic Product: 

```r
WDIsearch('gdp')
```

Which produces this: 

```r
> WDIsearch('gdp')[1:10,]
      indicator              name                                                                      
 [1,] "BG.GSR.NFSV.GD.ZS"    "Trade in services (% of GDP)"                                            
 [2,] "BM.KLT.DINV.GD.ZS"    "Foreign direct investment, net outflows (% of GDP)"                      
 [3,] "BN.CAB.XOKA.GD.ZS"    "Current account balance (% of GDP)"                                      
 [4,] "BN.CUR.GDPM.ZS"       "Current account balance excluding net official capital grants (% of GDP)"
 [5,] "BN.GSR.FCTY.CD.ZS"    "Net income (% of GDP)"                                                   
 [6,] "BN.KLT.DINV.CD.ZS"    "Foreign direct investment (% of GDP)"                                    
 [7,] "BN.KLT.PRVT.GD.ZS"    "Private capital flows, total (% of GDP)"                                 
 [8,] "BN.TRF.CURR.CD.ZS"    "Net current transfers (% of GDP)"                                        
 [9,] "BNCABFUNDCD_"         "Current Account Balance, %GDP"                                           
[10,] "BX.KLT.DINV.WD.GD.ZS" "Foreign direct investment, net inflows (% of GDP)" 
```

`WDIsearch` uses grep and ignores cases, so you can also use regular expressions. For instance, if you are looking for GDP per capita in constant dollars: 

```r
WDIsearch('gdp.*capita.*constant')
     indicator           name                                                 
[1,] "GDPPCKD"           "GDP per Capita, constant US$, millions"             
[2,] "NY.GDP.PCAP.KD"    "GDP per capita (constant 2000 US$)"                 
[3,] "NY.GDP.PCAP.KN"    "GDP per capita (constant LCU)"                      
[4,] "NY.GDP.PCAP.PP.KD" "GDP per capita, PPP (constant 2005 international $)"
```

# Download and use the data

Download a series you like for the countries you like:

```r
dat = WDI(indicator='NY.GDP.PCAP.KD', country=c('MX','CA','US'), start=1960, end=2012)
```

Look at the data: 

```r
head(dat)
  iso2c country NY.GDP.PCAP.KD year
1    CA  Canada       9374.883 1960
2    CA  Canada       9479.824 1961
3    CA  Canada       9967.366 1962
4    CA  Canada      10290.362 1963
5    CA  Canada      10774.653 1964
6    CA  Canada      11283.606 1965
```

Plot the data:

```r
library(ggplot2)
ggplot(dat, aes(year, NY.GDP.PCAP.KD, color=country)) + geom_line() + 
    xlab('Year') + ylab('GDP per capita')
```

![GDP per capita in North America](https://raw.githubusercontent.com/vincentarelbundock/WDI/main/web/gdp_per_capita.jpg)

Note: You can use `country='all'` to download data for all available countries. You can also feed a vector of indicator strings if you want to download multiple indicators at once.

# Monthly or quarterly data

Some World Bank series are available at the monthly or quarterly frequency. You can download those simply using the `start` and `end` arguments:

```r
WDI(indicator = 'DPANUSSPB', country = 'CHN', start = '2012M01', end = '2012M05')

  iso2c country DPANUSSPB    year
1   CHN   China  6.324130 2012M05
2   CHN   China  6.303810 2012M04
3   CHN   China  6.313545 2012M03
4   CHN   China  6.300286 2012M02
5   CHN   China  6.313091 2012M01
```

# Automatic rename

If the vector that you supply to ``WDI`` is named, the function will automatically rename columns where possible.

```r
dat <- WDI(indicator = c("gdp_per_capita" = "NY.GDP.PCAP.KD",
                         "population" = "SP.POP.TOTL"))
head(dat)
iso2c    country year gdp_per_capita population
1    1A Arab World 2005       5378.379  316264728
2    1A Arab World 2006       5594.899  323773264
3    1A Arab World 2007       5711.663  331653797
4    1A Arab World 2008       5898.516  339825483
5    1A Arab World 2009       5782.422  348145094
6    1A Arab World 2010       5916.330  356508908
```

# Updating series list

To speed up search, `WDI` ships with a local list of all available WDI series. This list will be updated semi-regularly, but you may still want to update it manually to get access to the very latest data series. To do so, use the `cache` function:

```r
new_cache = WDIcache()
WDIsearch('gdp', cache=new_cache)
```

# Bugs, suggestions, etc.

Thanks for using `WDI`! Please send all bug reports and suggestions through the github issue tracker or by email to vincent.arel-bundock@umontreal.ca

#' Search, extract and format data from the World Bank's World Development Indicators
#' 
#' The \code{WDI} function provides convenient access to over 40 databases
#' hosted by the World Bank, including the World Development Indicators (WDI),
#' International Debt Statistics, Doing Business, Human Capital Index, and
#' Sub-national poverty indicators.  For fast searching, the WDI package ships
#' with a local list of available data series. This local list can be updated
#' to the latest version using the \code{WDIcache} function. 
#' 
#' @name WDI-package
#' @aliases WDI-package
#' @title Search, extract, and format data from the World Bank
#' @author Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
#' @references
#'     \url{http://arelbundock.com}
#'     \url{https://github.com/vincentarelbundock/WDI}
#' @docType package
#' @keywords package
NULL

#' World Development Indicators series and country information 
#'
#' A list of two character matrices. 
#'
#' The first character matrix includes a full list of WDI series. This list is updated semi-regularly. Users can refresh the list manually using the `WDIcache()` function and search in the updated list using the `cache` argument.
#' 
#' \itemize{
#'   \item id WDI indicator code  
#'   \item name Short name of the series
#'   \item sourceNote Detailed description provided by the source
#'   \item source Source database
#'   \item sourceOrganization Source organization
#' }
#' 
#' The second character matrix includes extra country information (updated 2012-06-18):
#'
#' \itemize{
#'   \item iso3c ISO 3-letter country code  
#'   \item iso2c ISO 2-letter country code  
#'   \item country Country name (long English form)
#'   \item region Region
#'   \item capital Capital 
#'   \item longitude Longitude 
#'   \item latitude Latitude
#'   \item income Income level as defined by the World Bank
#'   \item lending Lending category, as defined by the World Bank
#' }

#' @docType data
#' @keywords datasets
#' @name WDI_data 
#' @usage WDI_data
#' @encoding UTF-8 
#' @format List of 2 data frames 
NULL

# https://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when#comment20826625_12429344
# 2012 hadley says "globalVariables is a hideous hack and I will never use it"
# 2014 hadley updates his own answer with globalVariables as one of "two solutions"
globalVariables(c('year', 'value', 'Country.Name', 'Country.Code', 'Indicator.Name', 'Indicator.Code'))

#' WDI: World Development Indicators (World Bank)
#' 
#' Downloads the requested data by using the World Bank's API, parses the
#' resulting XML file, and formats it in long country-year format. 
#' 
#' @param country Vector of countries (ISO-2 character codes, e.g. "BR", "US",
#'     "CA") for which the data is needed. Using the string "all" instead of
#'     individual iso codes pulls data for every available country.
#' @param indicator Character vector of indicators codes. See the WDIsearch()
#' function. If you supply a named vector, the indicators will be automatically
#' renamed: `c('women_private_sector' = 'BI.PWK.PRVS.FE.ZS')`
#' @param start Start date, usually a year in integer format. Must be 1960 or
#' greater.
#' @param end End date, usually a year in integer format. Must be greater than
#' the `start` argument.
#' @param extra TRUE returns extra variables such as region, iso3c code, and
#'     incomeLevel. See Details.
#' @param cache NULL (optional) a list created by WDIcache() to be used with the extra=TRUE argument.
#' @param latest Integer indicating the number of most recent non-NA values to get. Default is NULL. If specified, it overrides the start and end dates.
#' @param language ISO-2 code in lower case indicating in which language the characters should be provided. List of languages available with `WDI::languages_supported()`. Default is English.
#'     
#'     
#' @details It is possible to only specify the `indicator` and the `country` arguments, in which case `WDI()` will return data from 1960 to the last year available on World Bank's website. It is also possible to get only the most recent non-NA values, with `latest`.
#' 
#' If `extra = TRUE`, additional variables are provided:
#' 
#' \itemize{
#' 
#' \item{status: observation status, e.g is the observation a forecast?}
#' \item{iso3c}
#' \item{region}
#' \item{capital: name of the capital city}
#' \item{latitude, longitude}
#' \item{income: income categories of the World Bank}
#' \item{lending}
#' 
#' }
#' 
#' @return Data frame with country-year observations. You can extract a
#' data.frame with indicator names and descriptive labels by inspecting the
#' `label` attribute of the resulting data.frame: `attr(dat, 'label')`
#' @author Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
#' @importFrom RJSONIO fromJSON
#' @export
#'
#' @examples
#'
#' \dontrun{
#'
#' WDI(country="all", indicator=c("AG.AGR.TRAC.NO","TM.TAX.TCOM.BC.ZS"),
#'     start=1990, end=2000)
#' WDI(country=c("US","BR"), indicator="NY.GNS.ICTR.GN.ZS", start=1999, end=2000,
#'     extra=TRUE, cache=NULL)
#'
#' # Rename indicators on the fly
#' WDI(country = 'CA', indicator = c('women_private_sector' = 'BI.PWK.PRVS.FE.ZS',
#'                                   'women_public_sector' = 'BI.PWK.PUBS.FE.ZS'))
#'                                   
#' # Get the 5 latest non-NA values
#' WDI(country=c("US","BR"), indicator="NY.GNS.ICTR.GN.ZS", latest = 5)
#' }
#'
WDI <- function(country = "all",
                indicator = "NY.GDP.PCAP.KD",
                start = 1960,
                end = 2025,
                extra = FALSE,
                cache = NULL,
                latest = NULL,
                language = "en") {


    # Sanity: country
    if (!is.character(country)) {
        stop('The `country` argument must be a character vector')
    }

    country <- gsub('[^a-zA-Z0-9]', '', country)
    country_good <- unique(c(WDI::WDI_data$country[,'iso3c'], 
                             WDI::WDI_data$country[,'iso2c']))
    country_good <- c('all', country_good)
    country_bad <- base::setdiff(country, country_good)
    country <- base::intersect(country, country_good)

    if (length(country) == 0) {
        stop('None of the countries requested are valid. Please use ISO-2, ISO-3, or World Bank regional codes.')
    }
    if (length(country_bad) > 0) {
        warning('Please use ISO-2, ISO-3, or World Bank regional codes. Some of the country codes that you requested are invalid: ',  
                paste(country_bad, collapse = ', '))
    }

    # Sanity: start & end
    is_integer <- function(x) is.numeric(x) && (x %% 1 == 0)
    
    # If latest is specified then the good order of dates doesn't matter
    if (!is.null(start) && !is.null(end) && is.null(latest)) {
      if(!(start <= end)){
        stop('`end` must be equal to or greater than `start`.')
      }
      if (is_integer(start) && (start < 1960)) {
        stop('`start` must be equal to or greater than 1960')
      }
    }
    
    # Sanity: needs dates or number of most recent values (but not both)
    if (is.null(start) && is.null(end) && is.null(latest)) {
      stop("Need to specify dates or number of latest values.")
    }
    
    
    # "Language" option (placed here and not in wdi.query because
    # otherwise tryCatch doesn't show the expected error message)
    # get the two first letters (iso code)
    supported_fully <- substr(languages_supported()$fully, 
                              start = 1, 
                              stop = 2)
    supported_locally <- substr(languages_supported()$locally, 
                                start = 1, 
                                stop = 2)
    if (is.null(language)) {
      language <- "en"
    } else {
      if (language %in% supported_locally) {
        warning("This language is only supported partially.")
      } else if (!(language %in% supported_locally ||  
                   language %in% supported_fully)) {
        stop(paste0("This language is not supported. Run ",
                    "WDI::languages_supported() to have a list of ",
                    "fully and partially supported languages."))
      }
    }
    

    # Download
    dat <- list()
    failed <- NULL

    for (i in indicator) {
        tmp <- tryCatch(wdi.dl(i, country, start, end, latest, language, extra), error = function(e) e)
        if (is.null(tmp) || !inherits(tmp$data, 'data.frame') || (nrow(tmp$data) == 0)) {
            failed <- c(failed, i)
        } else {
            dat[[i]] <- tmp
        }
    }

    # Sanity: downloaded data
    if (length(failed) > 0) {

        msg <- sprintf(
'The following indicators could not be downloaded: %s.

Please make sure that you are running the latest version of the `WDI` package, and that the arguments you are using in the `WDI()` function are valid.

Sometimes, downloads will suddenly stop working, even if nothing has changed in the R code of the WDI package. ("The same WDI package version worked yesterday!") In those cases, the problem is almost certainly related to the World Bank servers or to your internet connection.

You can check if the World Bank web API is currently serving the indicator(s) of interest by typing a URL of this form in your web browser:

%s',
paste(failed, collapse = ", "),
wdi.query(indicator = failed[1])[1])

        if (length(failed) == length(indicator)) {
            stop(msg)
        } else if (length(failed) > 0) {
            warning(msg)
        }
    }

    # Extract labels
    lab = lapply(dat, function(x) data.frame('indicator' = x$indicator,
                                             'label' = x$label,
                                             stringsAsFactors = FALSE))
    lab = do.call('rbind', lab)

    # Extract data
    dat = lapply(dat, function(x) x$data)
    dat = Reduce(function(x,y) merge(x,y,all=TRUE), dat)
    row.names(dat) <- NULL

    # Extras
    if(!is.null(cache)){
        country_data = cache$country
    }else{
        country_data = WDI::WDI_data$country
    }
    if(extra==TRUE){
	    dat = merge(dat, country_data, all.x=TRUE)
    }
    countries = country[country != 'all' & !(country %in% dat$iso2c)]
    if(length(countries) > 0){
    }

    # Assign label attributes
    for (i in 1:nrow(lab)) {
        if (lab$indicator[i] %in% colnames(dat)) {
            attr(dat[[lab$indicator[i]]], 'label') = lab$label[[i]]
        }
    }

	# Rename columns based on indicator vector names
	if (!is.null(names(indicator))) {
		for (i in seq_along(indicator)) {
			idx = match(indicator[i], colnames(dat))
			if (!is.na(idx)) {
				colnames(dat)[idx] = names(indicator)[i]
			}
		}
	}

	# Output
  return(dat)
}

#' Download all the WDI indicators at once.
#' 
#' @return Data frame 
#' @author Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
#' @param timeout integer maximum number of seconds to wait for download
#' @return a list of 6 data frames: Data, Country, Series, Country-Series,
#' Series-Time, FootNote
#' @export
WDIbulk = function(timeout = 600) {

    # store default option
    oo <- options(timeout = timeout)

    if (!'tidyr' %in% utils::installed.packages()[, 1]) {
        stop('To use the `WDIbulk` function, you must install the `tidyr` package.')
    }

    # download
    temp_dir = tempdir()
    temp_file = tempfile(tmpdir = temp_dir)
    url = 'https://databank.worldbank.org/data/download/WDI_csv.zip'
    utils::download.file(url, temp_file)

    # read
    unzipped <- utils::unzip(zipfile = temp_file,
                             exdir = temp_dir)

    out = lapply(unzipped, function(x){
        utils::read.csv(x, stringsAsFactors = FALSE)
    })

    # flush
    unlink(temp_file)

    # names
    names(out) = c("Data", "Country", "Series",
                   "Country-Series", "Series-Time",
                   "FootNote")

    # clean "Data" entry
    out$Data$X = NULL

    out$Data = tidyr::pivot_longer(
        data = out$Data,
        cols = tidyr::starts_with("X"),
        names_to = "year",
        names_prefix = "X",
        values_to = "value"
    )

    # clean year column
    out$Data$year = as.integer(out$Data$year)

    # restore default option
    on.exit(options(oo))

    # output
    return(out)
}

#' Internal function to build API call
#'
#' @export
#' @keywords internal
wdi.query = function(indicator = "NY.GDP.PCAP.CD", 
                     country = 'all', 
                     start = 1960, 
                     end = 2020,
                     latest = NULL,
                     language = "en") {

    country <- paste(country, collapse = ';')
    
    # "Latest" option
    if (!is.null(latest)) {
      latest <- paste0("&mrnev=", latest)
    }
    
    # If latest is specified, dates are overridden
    if (!is.null(start) && !is.null(end)) {
      if (is.null(latest)) {
        years <- paste0("&date=", start, ":", end)
      } else {
        years <- NULL
      }
    } else {
      years <- NULL
    }

    # WDI only allows 32500 per_page (this seems undocumented)
    out = paste0("https://api.worldbank.org/v2/",
                 language, 
                 "/country/", 
                 country, "/indicator/", indicator,
                 "?format=json",
                 years,
                 "&per_page=32500",
                 "&page=", 1:10,
                 latest)
    return(out)
}

#' Internal function to download data
#'
#' @export
#' @keywords internal
wdi.dl = function(indicator, country, start, end, latest = NULL, language = "en", extra = FALSE){
    get_page <- function(daturl) {
        # download
        dat_raw = RJSONIO::fromJSON(daturl, nullValue=NA)[[2]]
        # extract data 
        dat = lapply(dat_raw, function(j) cbind(j$country[[1]], j$country[[2]], j$value, j$date, j$obs_status))
        dat = data.frame(do.call('rbind', dat), stringsAsFactors = FALSE)
        colnames(dat) = c('iso2c', 'country', as.character(indicator), 'year', "status")
        dat$status <- ifelse(dat$status == "F", "forecast", dat$status)
        if (!isTRUE(extra)) {
          dat$status <- NULL
        }
        dat$label <- dat_raw[[1]]$indicator['value']
        # output
        return(dat)
    }

    pages <- wdi.query(indicator, country, start, end, latest, language)

    dat <- list()
    done <- FALSE # done when pages no longer return useable info
    for (i in seq_along(pages)) {
        if (!done) {
            tmp <- tryCatch(get_page(pages[i]), error = function(e) NULL)
            if (inherits(tmp, 'data.frame') && (nrow(tmp) > 0)) {
                dat[[i]] <- tmp
            } else {
                done <- TRUE
            }
        }
    }
    dat <- do.call('rbind', dat)

    # numeric types
    dat[[indicator]] <- as.numeric(dat[[indicator]])

    # date is character for monthly/quarterly data, numeric otherwise
    if (!any(grepl('M|Q', dat$year))) {
        dat$year <- as.integer(dat$year)
    }

    # Bad data in WDI JSON files require me to impose this constraint
    if (!is.null(start) && !is.null(end)) {
      dat = dat[!is.na(dat$year) & dat$year <= end & dat$year >= start,] 
    }

    # output
    out = if (isTRUE(extra)) {
      list('data' = dat[, 1:5],
           'indicator' = indicator,
           'label' = dat$label[1])
    } else {
      list('data' = dat[, 1:4],
           'indicator' = indicator,
           'label' = dat$label[1])
    }

    return(out)
}

#' Update the list of available WDI indicators
#'
#' Download an updated list of available WDI indicators from the World Bank website. Returns a list for use in the \code{WDIsearch} function. 
#' 
#' @return Series of indicators, sources and descriptions in two lists list  
#' @note Downloading all series information from the World Bank website can take time.
#' The \code{WDI} package ships with a local data object with information on all the series
#' available on 2012-06-18. You can update this database by retrieving a new list using \code{WDIcache}, and  then
#' feeding the resulting object to \code{WDIsearch} via the \code{cache} argument. 
#' @export
WDIcache = function(){
    # Series
    series_url = 'https://api.worldbank.org/v2/indicator?per_page=25000&format=json'
    series_dat    = RJSONIO::fromJSON(series_url, nullValue=NA)[[2]]
    series_dat = lapply(series_dat, function(k) cbind(
                        'indicator'=k$id, 'name'=k$name, 'description'=k$sourceNote, 
                        'sourceDatabase'=k$source[2], 'sourceOrganization'=k$sourceOrganization)) 
    series_dat = do.call('rbind', series_dat)          
    # Countries
    country_url = 'https://api.worldbank.org/v2/countries/all?per_page=25000&format=json'
    country_dat = RJSONIO::fromJSON(country_url, nullValue=NA)[[2]]
    country_dat = lapply(country_dat, function(k) cbind(
                         'iso3c'=k$id, 'iso2c'=k$iso2Code, 'country'=k$name, 'region'=k$region[['value']],
                         'capital'=k$capitalCity, 'longitude'=k$longitude, 'latitude'=k$latitude, 
                         'income'=k$incomeLevel[['value']], 'lending'=k$lendingType[['value']])) 
    country_dat = do.call('rbind', country_dat)
    row.names(country_dat) = row.names(series_dat) = NULL
    out = list('series'=series_dat, 'country'=country_dat)
    out$series = iconv(out$series, to = 'utf8')
    out$country = iconv(out$country, to = 'utf8')
    # some regions have extra whitespace in wb data
    out$country[, 'region'] = base::trimws(out$country[, 'region'])
    return(out)
}

#' Search names and descriptions of available WDI series
#' 
#' Data frame with series code, name, description, and source for the WDI series
#' which match the given criteria
#' 
#' @param string Character string. Search for this string using \code{grep} with
#'     \code{ignore.case=TRUE}.
#' @param field Character string. Search this field. Admissible fields:
#'     'indicator', 'name', 'description', 'sourceDatabase', 'sourceOrganization'
#' @param short TRUE: Returns only the indicator's code and name. FALSE: Returns
#'     the indicator's code, name, description, and source.
#' @param cache Data list generated by the \code{WDIcache} function. If omitted,
#'     \code{WDIsearch} will search a local list of series.  
#' @return Data frame with code, name, source, and description of all series which
#'     match the criteria.  
#' @export
#' @examples
#' \dontrun{
#' WDIsearch(string='gdp', field='name', cache=NULL)
#' WDIsearch(string='AG.AGR.TRAC.NO', field='indicator', cache=NULL)
#' }
WDIsearch <- function(string="gdp", field="name", short=TRUE, cache=NULL){
    if(!is.null(cache)){ 
        series = cache$series    
    }else{
        series = WDI::WDI_data$series
    }
    matches = grep(string, series[,field], ignore.case=TRUE)
    if(short){
        out = series[matches, c('indicator', 'name')]
    }else{
        out = series[matches,]
    }
    return(out)
}


#' List of supported languages
#' 
#' This prints two lists of languages, the fully supported ones and the locally supported ones:
#' * the languages in the category "fully" will return translated names and other info for all countries.
#' * the languages in the category "partially" will return translated names and other info only for the country they represent. 
#' 
#' For example, choosing "vi" (for Vietnamese) will translate "Vietnam" in the dataset but other country names won't be translated and will be empty.
#'
#'
#' @return A list of fully and partially supported languages.
#' @export
languages_supported <- function() {
  
    fully <- c("en (English)", "es (Spanish)", "fr (French)", 
               "ar (Arabic)", "zh (Chinese)")
    locally <- c("bg (Bulgarian)", "de (German)", "hi (Hindi)", 
                 "id (Indonesian)", "ja (Japanese)", "km (Khmer)", 
                 "ko (Korean)", "mk (Macedonian)", "mn (Mongolian)",
                 "pl (Polish)", "pt (Portuguese)", "ro (Romanian)",
                 "ru (Russian)", "sq (Albanian)", "th (Thai)", "tr (Turkish)",
                 "uk (Ukrainian)", "vi (Vietnamese)")
    
    list(
      fully = fully,
      locally = locally
    )
    
}

skip_on_cran()

library(WDI)


test_that("extra includes last updated", {
    x <- WDI(extra = TRUE)
    expect_true("lastupdated" %in% colnames(x))
})

# breaks on travis but works locally
test_that("WDIcache", {
    cache = WDIcache()
    expect_type(cache, "list")
    expect_gte(nrow(cache$series), 20000)
    # web cache = stored cache
    old <- WDIsearch("gdp.*capita.*constant")
    new <- WDIsearch("gdp.*capita.*constant", cache = cache)
    row.names(old) <- row.names(new) <- NULL
    expect_identical(old, new)
})

test_that("Bad indicator", {
    expect_warning(expect_s3_class(
        WDI(indicator = c("NY.GDP.PCAP.KD", "test"), country = "US", start = 1990, end = 1991),
        "data.frame"))
    expect_error(expect_null(
        WDI(indicator = c("bad", "test"), country = "US", start = 1990, end = 1990)))
})

test_that("Bad country", {
    expect_error(WDI(country = c("bad")))
    expect_warning(WDI(country = c("CA", "bad"), start = 1990, end = 1991))
})

test_that("Bad year", {
    expect_error(WDI(start = 1950))
    expect_error(WDI(start = 1991, end = 1990))
    expect_error(WDI(start = "1990M2", end = "1990M1"))
})

test_that("WDI", {
    # 1 country 1 indicator
    x <- WDI(country = "US", indicator = "NY.GDP.PCAP.KD", start = 1990, end = 1991)
    expect_s3_class(x, "data.frame")
    expect_equal(dim(x), c(2, 5))

    # 3 countries 1 indicator
    x <- WDI(
        country = c("CA", "MX", "US"),
        indicator = "NY.GDP.PCAP.KD",
        start = 1990, end = 1991)
    expect_s3_class(x, "data.frame")
    expect_equal(dim(x), c(6, 5))
    expect_equal(length(unique(x$iso2c)), 3)

    # multiple indicators
    ind <- c("NY.GDP.PCAP.KD", "NY.GDP.PCAP.KN", "NY.GDP.PCAP.PP.KD")
    x <- WDI(indicator = ind, start = 1990, end = 1991)
    expect_gte(nrow(x), 30)
    expect_equal(ncol(x), 7)

    # bad countries
    co <- c("BADCOUNTRY_one", "BADCOUNTRY_two", "CA", "MX", "US")
    x <- expect_warning(WDI(country = co, start = 1990, end = 1991))
    expect_equal(length(unique(x$iso2c)), 3)

    # bad indicator
    ind <- c("blah blah", "NY.GDP.PCAP.KD", "NY.GDP.PCAP.KN", "NY.GDP.PCAP.PP.KD", "NY.GDP.PCAP.PP.KD.87")
    x <- expect_warning(WDI(indicator = ind, start = 1990, end = 1991))
    expect_gte(nrow(x), 30)
    expect_equal(ncol(x), 7)
})

test_that("WDI(extra = TRUE)", {
    x <- WDI(
        country = "US", indicator = "NY.GDP.PCAP.KD",
        start = 1991, end = 1992, extra = TRUE)
    expect_s3_class(x, "data.frame")
    expect_equal(dim(x), c(2, 13))
})

test_that("extra = TRUE provides observation status", {
    x <- WDI(
        country = "US", indicator = "NY.GDP.PCAP.KD",
        start = 1991, end = 1992, extra = TRUE)
    expect_true("status" %in% names(x))
    expect_true(is.character(x$status))
})

test_that("behavior of start/end dates with latest", {
    expect_silent(
        WDI("all", "NY.GDP.PCAP.KD", start = NULL, end = NULL, latest = 5)
    )
    expect_silent(
        WDI("all", "NY.GDP.PCAP.KD", start = 1980, end = 2000)
    )
})

test_that("latest provides a dataframe", {
    y <- WDI("all", "NY.GDP.PCAP.KD", start = NULL, end = NULL, latest = 5)
    expect_s3_class(y, "data.frame")

    z <- WDI("all", "NY.GDP.PCAP.KD", latest = 5)
    expect_s3_class(z, "data.frame")
})

test_that("check that language doesn't change output format", {
    x <- suppressWarnings(
        WDI("all", "NY.GDP.PCAP.KD", language = "vi")
    )
    expect_s3_class(x, "data.frame")
})

test_that("default language is english", {
    x <- WDI("all", "NY.GDP.PCAP.KD")
    y <- WDI("all", "NY.GDP.PCAP.KD", language = "en")
    expect_true(identical(x, y))
})

test_that("NULL language is equivalent to english", {
    x <- WDI("all", "NY.GDP.PCAP.KD", language = NULL)
    y <- WDI("all", "NY.GDP.PCAP.KD", language = "en")
    expect_true(identical(x, y))
})

test_that("error if language not in list", {
    expect_error(
        WDI("all", "NY.GDP.PCAP.KD", language = "xyz")
    )
})

test_that("warning if language only supported partially", {
    expect_warning(
        WDI("all", "NY.GDP.PCAP.KD", language = "vi")
    )
})

test_that("languages_supported produces a list", {
    expect_type(
        languages_supported(),
        "list"
    )
})


test_that("rename on the fly", {
    ind <- c("women_private_sector" = "BI.PWK.PRVS.FE.ZS", "women_public_sector" = "BI.PWK.PUBS.FE.ZS")
    x <- WDI(country = "CA", indicator = ind)
    expect_identical(
        colnames(x),
        c("country", "iso2c", "iso3c", "year", "women_private_sector", "women_public_sector"))
})


test_that("fix iso codes wrongly attributed to iso2 or iso3, issue #54", {
    dat <- WDI(
        indicator = c("DT.ODA.ODAT.GN.ZS", "DT.ODA.ODAT.GD.ZS"),
        country = c("AO", "CG", "SA", "MZ"), start = 2000, end = 2020)

    expect_equal(unique(dat$iso3c), c("AGO", "COG", "MOZ", "SAU"))

    expect_equal(unique(dat$iso2c), c("AO", "CG", "MZ", "SA"))
})

skip_on_cran()

library(WDI)

# breaks on travis but works locally
test_that('WDIcache', {

    cache = WDIcache()

    expect_type(cache, 'list')
    expect_gte(length(cache$series), 15000)

    # web cache = stored cache
    old <- WDIsearch('gdp.*capita.*constant')
    new <- WDIsearch('gdp.*capita.*constant', cache=cache)
    expect_identical(old, new)

})

test_that('Bad indicator' , {
    expect_warning(expect_s3_class(
        WDI(indicator = c('NY.GDP.PCAP.KD', 'test'), country = 'US', start = 1990, end = 1991),
        'data.frame'))
    expect_error(expect_null(
        WDI(indicator = c('bad', 'test'), country = 'US', start = 1990, end = 1990)))
})

test_that('Bad country', {
    expect_error(WDI(country = c('bad')))
    expect_warning(WDI(country = c('CA', 'bad'), start = 1990, end = 1991))
})

test_that('Bad year', {
    expect_error(WDI(start = 1950))
    expect_error(WDI(start = 1991, end = 1990))
    expect_error(WDI(start = '1990M2', end = '1990M1'))
})

test_that('WDI', {

    # 1 country 1 indicator
    x <- WDI(country='US', indicator='NY.GDP.PCAP.KD', start = 1990, end = 1991)
    expect_s3_class(x, 'data.frame')
    expect_equal(dim(x), c(2, 4))

    # 3 countries 1 indicator
    x <- WDI(country=c('CA', 'MX', 'US'),
             indicator='NY.GDP.PCAP.KD',
             start=1990, end=1991)
    expect_s3_class(x, 'data.frame')
    expect_equal(dim(x), c(6, 4))
    expect_equal(length(unique(x$iso2c)), 3)

    # multiple indicators
    ind <- c("NY.GDP.PCAP.KD", "NY.GDP.PCAP.KN", "NY.GDP.PCAP.PP.KD")
    x <- WDI(indicator = ind, start=1990, end=1991)
    expect_gte(nrow(x), 30)
    expect_equal(ncol(x), 6)

    # bad countries
    co <- c('BADCOUNTRY_one', 'BADCOUNTRY_two', 'CA', 'MX', 'US')
    x <- expect_warning(WDI(country = co, start=1990, end=1991))
    expect_equal(length(unique(x$iso2c)), 3)

    # bad indicator
    ind <- c("blah blah", "NY.GDP.PCAP.KD", "NY.GDP.PCAP.KN", "NY.GDP.PCAP.PP.KD", "NY.GDP.PCAP.PP.KD.87")
    x <- expect_warning(WDI(indicator = ind, start=1990, end=1991))
    expect_gte(nrow(x), 30)
    expect_equal(ncol(x), 6)

})

test_that('WDI(extra = TRUE)', {

    x <- WDI(country='US', indicator='NY.GDP.PCAP.KD',
             start=1991, end=1992, extra = TRUE)
    expect_s3_class(x, 'data.frame')
    expect_equal(dim(x), c(2, 12))

})

test_that("extra = TRUE provides observation status", {
    x <- WDI(country='US', indicator='NY.GDP.PCAP.KD',
             start=1991, end=1992, extra = TRUE)
    expect_true("status" %in% names(x))
    expect_true(is.character(x$status))
})

test_that("behavior of start/end dates with latest", {
   expect_silent(
        WDI("all", "AG.AGR.TRAC.NO", start = NULL, end = NULL, latest = 5)
    )
    expect_silent(
        WDI("all", "AG.AGR.TRAC.NO", start = 1980, end = 2000, latest = 5)
    )
})

test_that("latest provides a dataframe", {
   y <- WDI("all", "AG.AGR.TRAC.NO", start = NULL, end = NULL, latest = 5)
    expect_s3_class(y, "data.frame")

   z <- WDI("all", "AG.AGR.TRAC.NO", latest = 5)
   expect_s3_class(z, "data.frame")
})

test_that("check that language doesn't change output format", {
    x <- suppressWarnings(
        WDI("all", "AG.AGR.TRAC.NO", language = "vi")
    )
    expect_s3_class(x, "data.frame")
})

test_that("default language is english", {
    x <- WDI("all", "AG.AGR.TRAC.NO")
    y <- WDI("all", "AG.AGR.TRAC.NO", language = "en")
    expect_true(identical(x, y))
})

test_that("NULL language is equivalent to english", {
   x <- WDI("all", "AG.AGR.TRAC.NO", language = NULL)
   y <- WDI("all", "AG.AGR.TRAC.NO", language = "en")
   expect_true(identical(x, y))
})

test_that("error if language not in list", {
    expect_error(
        WDI("all", "AG.AGR.TRAC.NO", language = "xyz")
    )
})

test_that("warning if language only supported partially", {
    expect_warning(
        WDI("all", "AG.AGR.TRAC.NO", language = "vi")
    )
})

test_that("languages_supported produces a list", {
    expect_type(
        languages_supported(),
        "list"
    )
})


test_that("rename on the fly", {
    ind <- c("women_private_sector" = "BI.PWK.PRVS.FE.ZS", "women_public_sector" = "BI.PWK.PUBS.FE.ZS")
    x <- WDI(country = 'CA', indicator = ind)
    expect_identical(
        colnames(x),
        c("iso2c", "country", "year", "women_private_sector", "women_public_sector"))
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{wdi.query}
\alias{wdi.query}
\title{Internal function to build API call}
\usage{
wdi.query(
  indicator = "NY.GDP.PCAP.CD",
  country = "all",
  start = 1960,
  end = 2020,
  latest = NULL,
  language = "en"
)
}
\description{
Internal function to build API call
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{languages_supported}
\alias{languages_supported}
\title{List of supported languages}
\usage{
languages_supported()
}
\value{
A list of fully and partially supported languages.
}
\description{
This prints two lists of languages, the fully supported ones and the locally supported ones:
\itemize{
\item the languages in the category "fully" will return translated names and other info for all countries.
\item the languages in the category "partially" will return translated names and other info only for the country they represent.
}
}
\details{
For example, choosing "vi" (for Vietnamese) will translate "Vietnam" in the dataset but other country names won't be translated and will be empty.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{WDIsearch}
\alias{WDIsearch}
\title{Search names and descriptions of available WDI series}
\usage{
WDIsearch(string = "gdp", field = "name", short = TRUE, cache = NULL)
}
\arguments{
\item{string}{Character string. Search for this string using \code{grep} with
\code{ignore.case=TRUE}.}

\item{field}{Character string. Search this field. Admissible fields:
'indicator', 'name', 'description', 'sourceDatabase', 'sourceOrganization'}

\item{short}{TRUE: Returns only the indicator's code and name. FALSE: Returns
the indicator's code, name, description, and source.}

\item{cache}{Data list generated by the \code{WDIcache} function. If omitted,
\code{WDIsearch} will search a local list of series.}
}
\value{
Data frame with code, name, source, and description of all series which
    match the criteria.
}
\description{
Data frame with series code, name, description, and source for the WDI series
which match the given criteria
}
\examples{
\dontrun{
WDIsearch(string='gdp', field='name', cache=NULL)
WDIsearch(string='AG.AGR.TRAC.NO', field='indicator', cache=NULL)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{wdi.dl}
\alias{wdi.dl}
\title{Internal function to download data}
\usage{
wdi.dl(
  indicator,
  country,
  start,
  end,
  latest = NULL,
  language = "en",
  extra = FALSE
)
}
\description{
Internal function to download data
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{WDI}
\alias{WDI}
\title{WDI: World Development Indicators (World Bank)}
\usage{
WDI(
  country = "all",
  indicator = "NY.GDP.PCAP.KD",
  start = 1960,
  end = 2025,
  extra = FALSE,
  cache = NULL,
  latest = NULL,
  language = "en"
)
}
\arguments{
\item{country}{Vector of countries (ISO-2 character codes, e.g. "BR", "US",
"CA") for which the data is needed. Using the string "all" instead of
individual iso codes pulls data for every available country.}

\item{indicator}{Character vector of indicators codes. See the WDIsearch()
function. If you supply a named vector, the indicators will be automatically
renamed: `c('women_private_sector' = 'BI.PWK.PRVS.FE.ZS')`}

\item{start}{Start date, usually a year in integer format. Must be 1960 or
greater.}

\item{end}{End date, usually a year in integer format. Must be greater than
the `start` argument.}

\item{extra}{TRUE returns extra variables such as region, iso3c code, and
incomeLevel. See Details.}

\item{cache}{NULL (optional) a list created by WDIcache() to be used with the extra=TRUE argument.}

\item{latest}{Integer indicating the number of most recent non-NA values to get. Default is NULL. If specified, it overrides the start and end dates.}

\item{language}{ISO-2 code in lower case indicating in which language the characters should be provided. List of languages available with `WDI::languages_supported()`. Default is English.}
}
\value{
Data frame with country-year observations. You can extract a
data.frame with indicator names and descriptive labels by inspecting the
`label` attribute of the resulting data.frame: `attr(dat, 'label')`
}
\description{
Downloads the requested data by using the World Bank's API, parses the
resulting XML file, and formats it in long country-year format.
}
\details{
It is possible to only specify the `indicator` and the `country` arguments, in which case `WDI()` will return data from 1960 to the last year available on World Bank's website. It is also possible to get only the most recent non-NA values, with `latest`.

If `extra = TRUE`, additional variables are provided:

\itemize{

\item{status: observation status, e.g is the observation a forecast?}
\item{iso3c}
\item{region}
\item{capital: name of the capital city}
\item{latitude, longitude}
\item{income: income categories of the World Bank}
\item{lending}

}
}
\examples{

\dontrun{

WDI(country="all", indicator=c("AG.AGR.TRAC.NO","TM.TAX.TCOM.BC.ZS"),
    start=1990, end=2000)
WDI(country=c("US","BR"), indicator="NY.GNS.ICTR.GN.ZS", start=1999, end=2000,
    extra=TRUE, cache=NULL)

# Rename indicators on the fly
WDI(country = 'CA', indicator = c('women_private_sector' = 'BI.PWK.PRVS.FE.ZS',
                                  'women_public_sector' = 'BI.PWK.PUBS.FE.ZS'))
                                  
# Get the 5 latest non-NA values
WDI(country=c("US","BR"), indicator="NY.GNS.ICTR.GN.ZS", latest = 5)
}

}
\author{
Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI_data.R
\docType{data}
\encoding{UTF-8}
\name{WDI_data}
\alias{WDI_data}
\title{World Development Indicators series and country information}
\format{
List of 2 data frames
}
\usage{
WDI_data
}
\description{
A list of two character matrices.
}
\details{
The first character matrix includes a full list of WDI series. This list is updated semi-regularly. Users can refresh the list manually using the `WDIcache()` function and search in the updated list using the `cache` argument.

\itemize{
  \item id WDI indicator code  
  \item name Short name of the series
  \item sourceNote Detailed description provided by the source
  \item source Source database
  \item sourceOrganization Source organization
}

The second character matrix includes extra country information (updated 2012-06-18):

\itemize{
  \item iso3c ISO 3-letter country code  
  \item iso2c ISO 2-letter country code  
  \item country Country name (long English form)
  \item region Region
  \item capital Capital 
  \item longitude Longitude 
  \item latitude Latitude
  \item income Income level as defined by the World Bank
  \item lending Lending category, as defined by the World Bank
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{WDIbulk}
\alias{WDIbulk}
\title{Download all the WDI indicators at once.}
\usage{
WDIbulk(timeout = 600)
}
\arguments{
\item{timeout}{integer maximum number of seconds to wait for download}
}
\value{
Data frame

a list of 6 data frames: Data, Country, Series, Country-Series,
Series-Time, FootNote
}
\description{
Download all the WDI indicators at once.
}
\author{
Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI-package.R
\docType{package}
\name{WDI-package}
\alias{WDI-package}
\title{Search, extract, and format data from the World Bank}
\description{
Search, extract and format data from the World Bank's World Development Indicators
}
\details{
The \code{WDI} function provides convenient access to over 40 databases
hosted by the World Bank, including the World Development Indicators (WDI),
International Debt Statistics, Doing Business, Human Capital Index, and
Sub-national poverty indicators.  For fast searching, the WDI package ships
with a local list of available data series. This local list can be updated
to the latest version using the \code{WDIcache} function.
}
\references{
\url{http://arelbundock.com}
    \url{https://github.com/vincentarelbundock/WDI}
}
\author{
Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WDI.R
\name{WDIcache}
\alias{WDIcache}
\title{Update the list of available WDI indicators}
\usage{
WDIcache()
}
\value{
Series of indicators, sources and descriptions in two lists list
}
\description{
Download an updated list of available WDI indicators from the World Bank website. Returns a list for use in the \code{WDIsearch} function.
}
\note{
Downloading all series information from the World Bank website can take time.
The \code{WDI} package ships with a local data object with information on all the series
available on 2012-06-18. You can update this database by retrieving a new list using \code{WDIcache}, and  then
feeding the resulting object to \code{WDIsearch} via the \code{cache} argument.
}
